{{ low_pass.spin }}

CON

OBJ


PUB Start (param_address)
  RESULT := cognew (@entry, param_address)

DAT
                ORG     0
entry
                mov     parm, PAR
                rdlong  period, parm
		add	parm, #4
		rdlong  time, parm
		add	parm, #4
	        mov     in_addr, parm
                add     parm, #4
		mov	out_addr, parm

:filtloop       WAITCNT time, period   ' synchronize
		rdlong  value, in_addr
                call    #filter
                wrlong  value, out_addr
                jmp     #:filtloop


filter          
                sar     value, #6
                call    #stage1          ' stage gain = 100.360886485, cumul actual gain = 0.692131164558
                                         ' poles only = 44.2963945317
                sar     value, #4
                call    #stage2          ' stage gain = 16.6754913386, cumul actual gain = 0.905697915065
                                         ' poles only = 12.7782058068
                sar     value, #2
                call    #stage3          ' stage gain = 5.36898004285, cumul actual gain = 0.892060200297
                                         ' poles only = 5.94062489891
                call    #stage4          ' stage gain = 4.13706682627, cumul actual gain = 0.795483295242
                                         ' poles only = 3.62947237238
                shl     value, #1
                call    #stage5          ' stage gain = 9.14507518893, cumul actual gain = 0.511542964882
                                         ' poles only = 5.33639882397
                shl     value, #2
filter_ret      ret                      ' cumul actual gain = 0.518248170553

value           long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(-0.8759765625+0.48046875j), (-0.8759765625-0.48046875j)], p = [(0.25390625+0.955078125j), (0.25390625-0.955078125j)] }}

coeff1_b1                                ' value += t * -0.507812 [ +0.82000 hex ]
                sar     t, #1
                sub     value, t
                sar     t, #6
                sub     value, t
coeff1_b1_ret   ret                      ' 20 cycles (I2S: 0.203 us, standard: 0.250 us) 5 instructs

coeff1_b2                                ' value += t * 0.976562 [ +0.fa000 hex ]
                add     value, t
                sar     t, #5
                sub     value, t
                sar     t, #2
                add     value, t
coeff1_b2_ret   ret                      ' 24 cycles (I2S: 0.244 us, standard: 0.300 us) 6 instructs

coeff1_a1                                ' value += t * 1.751953 [ +1.c0800 hex ]
                add     value, t
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #7
                add     value, t
coeff1_a1_ret   ret                      ' 28 cycles (I2S: 0.285 us, standard: 0.350 us) 7 instructs

coeff1_a2                                ' value += t * 0.998047 [ +0.ff800 hex ]
                add     value, t
                sar     t, #9
                sub     value, t
coeff1_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage1          
                neg     t, w11
                call    #coeff1_b1       ' value -= w11 * -0.5078125
                neg     t, w12
                call    #coeff1_b2       ' value -= w12 * 0.9765625
                mov     w10, value       ' w10 = value
                mov     t, w11
                call    #coeff1_a1       ' value += w11 * 1.751953125
                mov     t, w12
                call    #coeff1_a2       ' value += w12 * 0.998046875
                mov     w12, w11
                mov     w11, w10         ' w12 <- w11 <- w10
stage1_ret      ret

w10             long    0
w11             long    0
w12             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(-0.3544921875+0.9345703125j), (-0.3544921875-0.9345703125j)], p = [(0.2841796875+0.9150390625j), (0.2841796875-0.9150390625j)] }}

coeff2_b1                                ' value += t * -0.568359 [ +0.91800 hex ]
                sar     t, #1
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                add     value, t
coeff2_b1_ret   ret                      ' 36 cycles (I2S: 0.366 us, standard: 0.450 us) 9 instructs

coeff2_b2                                ' value += t * 0.917969 [ +0.eb000 hex ]
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
coeff2_b2_ret   ret                      ' 40 cycles (I2S: 0.407 us, standard: 0.500 us) 10 instructs

coeff2_a1                                ' value += t * 0.708984 [ +0.b5800 hex ]
                sar     t, #1
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
coeff2_a1_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff2_a2                                ' value += t * 0.999023 [ +0.ffc00 hex ]
                add     value, t
                sar     t, #10
                sub     value, t
coeff2_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage2          
                neg     t, w21
                call    #coeff2_b1       ' value -= w21 * -0.568359375
                neg     t, w22
                call    #coeff2_b2       ' value -= w22 * 0.91796875
                mov     w20, value       ' w20 = value
                mov     t, w21
                call    #coeff2_a1       ' value += w21 * 0.708984375
                mov     t, w22
                call    #coeff2_a2       ' value += w22 * 0.9990234375
                mov     w22, w21
                mov     w21, w20         ' w22 <- w21 <- w20
stage2_ret      ret

w20             long    0
w21             long    0
w22             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(-0.0380859375+0.9990234375j), (-0.0380859375-0.9990234375j)], p = [(0.36328125+0.8271484375j), (0.36328125-0.8271484375j)] }}

coeff3_b1                                ' value += t * -0.726562 [ +0.ba000 hex ]
                sar     t, #1
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #2
                sub     value, t
coeff3_b1_ret   ret                      ' 36 cycles (I2S: 0.366 us, standard: 0.450 us) 9 instructs

coeff3_b2                                ' value += t * 0.815430 [ +0.d0c00 hex ]
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #4
                add     value, t
                sar     t, #2
                sub     value, t
coeff3_b2_ret   ret                      ' 40 cycles (I2S: 0.407 us, standard: 0.500 us) 10 instructs

coeff3_a1                                ' value += t * 0.076172 [ +0.13800 hex ]
                sar     t, #4
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                sub     value, t
coeff3_a1_ret   ret                      ' 28 cycles (I2S: 0.285 us, standard: 0.350 us) 7 instructs

coeff3_a2                                ' value += t * 0.999023 [ +0.ffc00 hex ]
                add     value, t
                sar     t, #10
                sub     value, t
coeff3_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage3          
                neg     t, w31
                call    #coeff3_b1       ' value -= w31 * -0.7265625
                neg     t, w32
                call    #coeff3_b2       ' value -= w32 * 0.8154296875
                mov     w30, value       ' w30 = value
                mov     t, w31
                call    #coeff3_a1       ' value += w31 * 0.076171875
                mov     t, w32
                call    #coeff3_a2       ' value += w32 * 0.9990234375
                mov     w32, w31
                mov     w31, w30         ' w32 <- w31 <- w30
stage3_ret      ret

w30             long    0
w31             long    0
w32             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(0.0947265625+0.9951171875j), (0.0947265625-0.9951171875j)], p = [(0.501953125+0.62890625j), (0.501953125-0.62890625j)] }}

coeff4_b1                                ' value += t * -1.003906 [ +1.01000 hex ]
                sub     value, t
                sar     t, #8
                sub     value, t
coeff4_b1_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

coeff4_b2                                ' value += t * 0.647461 [ +0.a5c00 hex ]
                sar     t, #1
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #3
                sub     value, t
coeff4_b2_ret   ret                      ' 44 cycles (I2S: 0.448 us, standard: 0.550 us) 11 instructs

coeff4_a1                                ' value += t * -0.189453 [ +0.30800 hex ]
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #5
                sub     value, t
coeff4_a1_ret   ret                      ' 28 cycles (I2S: 0.285 us, standard: 0.350 us) 7 instructs

coeff4_a2                                ' value += t * 0.999023 [ +0.ffc00 hex ]
                add     value, t
                sar     t, #10
                sub     value, t
coeff4_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage4          
                neg     t, w41
                call    #coeff4_b1       ' value -= w41 * -1.00390625
                neg     t, w42
                call    #coeff4_b2       ' value -= w42 * 0.6474609375
                mov     w40, value       ' w40 = value
                mov     t, w41
                call    #coeff4_a1       ' value += w41 * -0.189453125
                mov     t, w42
                call    #coeff4_a2       ' value += w42 * 0.9990234375
                mov     w42, w41
                mov     w41, w40         ' w42 <- w41 <- w40
stage4_ret      ret

w40             long    0
w41             long    0
w42             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(0.142578125+0.9892578125j), (0.142578125-0.9892578125j)], p = [(0.64453125+0.2470703125j), (0.64453125-0.2470703125j)] }}

coeff5_b1                                ' value += t * -1.289062 [ +1.4a000 hex ]
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                sub     value, t
coeff5_b1_ret   ret                      ' 32 cycles (I2S: 0.326 us, standard: 0.400 us) 8 instructs

coeff5_b2                                ' value += t * 0.475586 [ +0.79c00 hex ]
                sar     t, #1
                add     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                sub     value, t
coeff5_b2_ret   ret                      ' 36 cycles (I2S: 0.366 us, standard: 0.450 us) 9 instructs

coeff5_a1                                ' value += t * -0.285156 [ +0.49000 hex ]
                sar     t, #2
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #3
                sub     value, t
coeff5_a1_ret   ret                      ' 28 cycles (I2S: 0.285 us, standard: 0.350 us) 7 instructs

coeff5_a2                                ' value += t * 0.998047 [ +0.ff800 hex ]
                add     value, t
                sar     t, #9
                sub     value, t
coeff5_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage5          
                neg     t, w51
                call    #coeff5_b1       ' value -= w51 * -1.2890625
                neg     t, w52
                call    #coeff5_b2       ' value -= w52 * 0.4755859375
                mov     w50, value       ' w50 = value
                mov     t, w51
                call    #coeff5_a1       ' value += w51 * -0.28515625
                mov     t, w52
                call    #coeff5_a2       ' value += w52 * 0.998046875
                mov     w52, w51
                mov     w51, w50         ' w52 <- w51 <- w50
stage5_ret      ret

w50             long    0
w51             long    0
w52             long    0

t               res     1
{{ 10 bits per coefficient }}
{{ 920 cycles (I2S: 9.359 us, standard: 11.500 us) 230 instructs }}
parm            res     1
time            res     1
period          res     1
in_addr         res     1
out_addr        res     1
                FIT     $1F0
