{{ low_pass_bessel.spin }}

CON

OBJ


PUB Start (param_address)
  RESULT := cognew (@entry, param_address)

DAT
                ORG     0
entry
                mov     parm, PAR
                rdlong  period, parm
		add	parm, #4
		rdlong  time, parm
		add	parm, #4
	        mov     in_addr, parm
                add     parm, #4
		mov	out_addr, parm

:filtloop       WAITCNT time, period   ' synchronize
		rdlong  value, in_addr
                call    #filter
                wrlong  value, out_addr
                jmp     #:filtloop


filter          
                sar     value, #2
                call    #stage1          ' stage gain = 6.5436973692, cumul actual gain = 0.851263959591
                                         ' poles only = 3.40505583836
                sar     value, #3
                call    #stage2          ' stage gain = 7.50663559918, cumul actual gain = 0.648524845214
                                         ' poles only = 3.75331779959
                sar     value, #3
                call    #stage3          ' stage gain = 8.6463272874, cumul actual gain = 0.681700420012
                                         ' poles only = 4.3231636437
                sar     value, #1
filter_ret      ret                      ' cumul actual gain = 0.681700420012

value           long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [-1.0, 0.0], p = [(0.571197509765625+0.4336395263671875j), (0.571197509765625-0.4336395263671875j)] }}

coeff1_b1                                ' value += t * -1.142395 [ +1.24740 hex ]
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #2
                sub     value, t
coeff1_b1_ret   ret                      ' 48 cycles (I2S: 0.488 us, standard: 0.600 us) 12 instructs

coeff1_b2                                ' value += t * 0.514297 [ +0.83a90 hex ]
                sar     t, #1
                add     value, t
                sar     t, #5
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                add     value, t
coeff1_b2_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff1_a1                                ' value += t * 1.000000 [ +1.00000 hex ]
                add     value, t
coeff1_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff1_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff1_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage1          
                neg     t, w11
                call    #coeff1_b1       ' value -= w11 * -1.14239501953125
                neg     t, w12
                call    #coeff1_b2       ' value -= w12 * 0.5142974853515625
                mov     w10, value       ' w10 = value
                mov     t, w11
                call    #coeff1_a1       ' value += w11 * 1.0
                mov     t, w12
                call    #coeff1_a2       ' value += w12 * 0.0
                mov     w12, w11
                mov     w11, w10         ' w12 <- w11 <- w10
stage1_ret      ret

w10             long    0
w11             long    0
w12             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [-1.0, 0.0], p = [(0.5383453369140625+0.2308807373046875j), (0.5383453369140625-0.2308807373046875j)] }}

coeff2_b1                                ' value += t * -1.076691 [ +1.13a20 hex ]
                sub     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #4
                sub     value, t
coeff2_b1_ret   ret                      ' 48 cycles (I2S: 0.488 us, standard: 0.600 us) 12 instructs

coeff2_b2                                ' value += t * 0.343109 [ +0.57d60 hex ]
                sar     t, #2
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #5
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
coeff2_b2_ret   ret                      ' 60 cycles (I2S: 0.610 us, standard: 0.750 us) 15 instructs

coeff2_a1                                ' value += t * 1.000000 [ +1.00000 hex ]
                add     value, t
coeff2_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff2_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff2_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage2          
                neg     t, w21
                call    #coeff2_b1       ' value -= w21 * -1.076690673828125
                neg     t, w22
                call    #coeff2_b2       ' value -= w22 * 0.343109130859375
                mov     w20, value       ' w20 = value
                mov     t, w21
                call    #coeff2_a1       ' value += w21 * 1.0
                mov     t, w22
                call    #coeff2_a2       ' value += w22 * 0.0
                mov     w22, w21
                mov     w21, w20         ' w22 <- w21 <- w20
stage2_ret      ret

w20             long    0
w21             long    0
w22             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [-1.0, 0.0], p = [(0.524688720703125+0.07342529296875j), (0.524688720703125-0.07342529296875j)] }}

coeff3_b1                                ' value += t * -1.049377 [ +1.0ca40 hex ]
                sub     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                sub     value, t
coeff3_b1_ret   ret                      ' 48 cycles (I2S: 0.488 us, standard: 0.600 us) 12 instructs

coeff3_b2                                ' value += t * 0.280685 [ +0.47db0 hex ]
                sar     t, #2
                add     value, t
                sar     t, #3
                add     value, t
                sar     t, #5
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
coeff3_b2_ret   ret                      ' 60 cycles (I2S: 0.610 us, standard: 0.750 us) 15 instructs

coeff3_a1                                ' value += t * 1.000000 [ +1.00000 hex ]
                add     value, t
coeff3_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff3_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff3_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage3          
                neg     t, w31
                call    #coeff3_b1       ' value -= w31 * -1.04937744140625
                neg     t, w32
                call    #coeff3_b2       ' value -= w32 * 0.2806854248046875
                mov     w30, value       ' w30 = value
                mov     t, w31
                call    #coeff3_a1       ' value += w31 * 1.0
                mov     t, w32
                call    #coeff3_a2       ' value += w32 * 0.0
                mov     w32, w31
                mov     w31, w30         ' w32 <- w31 <- w30
stage3_ret      ret

w30             long    0
w31             long    0
w32             long    0

t               res     1
{{ 16 bits per coefficient }}
{{ 572 cycles (I2S: 5.819 us, standard: 7.150 us) 143 instructs }}
parm            res     1
time            res     1
period          res     1
in_addr         res     1
out_addr        res     1
                FIT     $1F0
