{{ notch.spin }}

CON

OBJ


PUB Start (param_address)
  RESULT := cognew (@entry, param_address)

DAT
                ORG     0
entry
                mov     parm, PAR
                rdlong  period, parm
		add	parm, #4
		rdlong  time, parm
		add	parm, #4
	        mov     in_addr, parm
                add     parm, #4
		mov	out_addr, parm

:filtloop       WAITCNT time, period   ' synchronize
		rdlong  value, in_addr
                call    #filter
                wrlong  value, out_addr
                jmp     #:filtloop


filter          
                sar     value, #3
                call    #stage1          ' stage gain = 1.08199295913, cumul actual gain = 0.853930643486
                                         ' poles only = 6.83144514788
                shl     value, #2
filter_ret      ret                      ' cumul actual gain = 0.540996479566

value           long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(0.2588043212890625+0.965911865234375j), (0.2588043212890625-0.965911865234375j)], p = [(0.23919677734375+0.889495849609375j), (0.23919677734375-0.889495849609375j)] }}

coeff1_b1                                ' value += t * -0.478394 [ +0.7a780 hex ]
                sar     t, #1
                sub     value, t
                sar     t, #4
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #4
                add     value, t
coeff1_b1_ret   ret                      ' 44 cycles (I2S: 0.448 us, standard: 0.550 us) 11 instructs

coeff1_b2                                ' value += t * 0.848404 [ +0.d9310 hex ]
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #4
                add     value, t
coeff1_b2_ret   ret                      ' 64 cycles (I2S: 0.651 us, standard: 0.800 us) 16 instructs

coeff1_a1                                ' value += t * -0.517609 [ +0.84820 hex ]
                sar     t, #1
                sub     value, t
                sar     t, #5
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #6
                sub     value, t
coeff1_a1_ret   ret                      ' 36 cycles (I2S: 0.366 us, standard: 0.450 us) 9 instructs

coeff1_a2                                ' value += t * 0.999954 [ +0.fffd0 hex ]
                add     value, t
                sar     t, #14
                sub     value, t
                sar     t, #2
                add     value, t
coeff1_a2_ret   ret                      ' 24 cycles (I2S: 0.244 us, standard: 0.300 us) 6 instructs

stage1          
                neg     t, w11
                call    #coeff1_b1       ' value -= w11 * -0.4783935546875
                neg     t, w12
                call    #coeff1_b2       ' value -= w12 * 0.8484039306640625
                mov     w10, value       ' w10 = value
                mov     t, w11
                call    #coeff1_a1       ' value += w11 * -0.517608642578125
                mov     t, w12
                call    #coeff1_a2       ' value += w12 * 0.9999542236328125
                mov     w12, w11
                mov     w11, w10         ' w12 <- w11 <- w10
stage1_ret      ret

w10             long    0
w11             long    0
w12             long    0

t               res     1
{{ 16 bits per coefficient }}
{{ 252 cycles (I2S: 2.563 us, standard: 3.150 us) 63 instructs }}
parm            res     1
time            res     1
period          res     1
in_addr         res     1
out_addr        res     1
                FIT     $1F0
